include:
  - project: gitlab-org/frontend/frontend-build-images
    file: /semantic-release/.gitlab-ci-template.rules.yml
  - project: gitlab-org/frontend/untamper-my-lockfile
    file: .gitlab-ci-template.yml

workflow:
  rules:
    - if: $CI_MERGE_REQUEST_IID
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH

stages:
  - test
  - build
  - publish

.node:
  image: node:16.13.1
  needs: []
  tags:
    - gitlab-org
  cache:
    paths:
      - node_modules/
  before_script:
    - yarn install --check-files --frozen-lockfile --non-interactive

build:
  extends: .node
  stage: build
  script:
    - yarn build
  artifacts:
    paths:
      - dist/
      - esm/

lint:
  extends: .node
  stage: test
  script:
    - yarn run test:lint

test:
  extends: .node
  stage: test
  script:
    - yarn run test:unit --coverage --maxWorkers=2

semantic-release:
  extends: .semantic-release
  needs:
    - build
  stage: publish

semantic-release-dry-run:
  extends: .semantic-release
  stage: publish
  needs:
    - build
  script: semantic-release --branches $CI_MERGE_REQUEST_SOURCE_BRANCH_NAME --dry-run
  rules:
    - if: $CI_MERGE_REQUEST_IID
